"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getConfiguration = void 0;
const cosmiconfig_1 = require("cosmiconfig");
const lodash_1 = require("lodash");
const getCliConfiguration = (args) => {
    var _a, _b, _c, _d, _e, _f;
    return ({
        threshold: {
            drift: {
                collective: ((_a = args["threshold-drift-collective"]) !== null && _a !== void 0 ? _a : args["D"]),
                individual: ((_b = args["threshold-drift-individual"]) !== null && _b !== void 0 ? _b : args["d"]),
            },
            pulse: {
                collective: ((_c = args["threshold-pulse-collective"]) !== null && _c !== void 0 ? _c : args["P"]),
                individual: ((_d = args["threshold-pulse-individual"]) !== null && _d !== void 0 ? _d : args["p"]),
            },
            releases: {
                collective: ((_e = args["threshold-releases-collective"]) !== null && _e !== void 0 ? _e : args["R"]),
                individual: ((_f = args["threshold-releases-individual"]) !== null && _f !== void 0 ? _f : args["r"]),
            },
            major: {
                collective: args["threshold-major-collective"],
                individual: args["threshold-major-individual"],
            },
            minor: {
                collective: args["threshold-minor-collective"],
                individual: args["threshold-minor-individual"],
            },
            patch: {
                collective: args["threshold-patch-collective"],
                individual: args["threshold-patch-individual"],
            },
        },
    });
};
const getCosmiconfig = async (filePath) => {
    const explorer = cosmiconfig_1.cosmiconfig("libyear");
    try {
        const result = filePath
            ? await explorer.load(filePath)
            : await explorer.search();
        return result.config;
    }
    catch (error) {
        return {};
    }
};
const getConfiguration = async (args) => lodash_1.merge(await getCosmiconfig(args["config"]), getCliConfiguration(args));
exports.getConfiguration = getConfiguration;
