"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getStableReleases = exports.getSanitisedReleases = exports.getReleasesByType = void 0;
const semver_1 = require("semver");
/**
 * Filter versions by release type.
 */
const getReleasesByType = (versions, type) => versions.filter((value, index, array) => { var _a; return semver_1.diff((_a = array[index - 1]) !== null && _a !== void 0 ? _a : value, value) === type; });
exports.getReleasesByType = getReleasesByType;
/**
 * Filter out "time" metadata about the package.
 */
const getSanitisedReleases = (releases) => new Map(Array.from(releases.entries()).filter(([version, _]) => semver_1.valid(version)));
exports.getSanitisedReleases = getSanitisedReleases;
/**
 * Filter pre-release versions.
 */
const getStableReleases = (releases) => new Map(Array.from(releases.entries()).filter(([version, _]) => semver_1.prerelease(version) == null));
exports.getStableReleases = getStableReleases;
